import numpy
import math

class Marker :
	K = numpy.matrix( [ [1000.0,    0.0, -300.0],
	                  [   0.0,   1000.0, -200.0],
	                  [   0.0,      0.0,   -1.0] ] )

	def __init__( self ) :
		self.v = numpy.zeros( (4,3) ) 
		self.img = numpy.zeros( (4,2) ) 


	def create( self, v1, v2 ) :
		self.v[0][0] = v2[0] 
		self.v[0][1] = v2[1]
		self.v[0][2] = 0.0

		self.v[1][0] = v1[0] 
		self.v[1][1] = v2[1]
		self.v[1][2] = 0.0

		self.v[2][0] = v1[0] 
		self.v[2][1] = v1[1]
		self.v[2][2] = 0.0

		self.v[3][0] = v2[0] 
		self.v[3][1] = v1[1]
		self.v[3][2] = 0.0

	def draw3D( self ) :
		print self.v[0][0], self.v[0][1], self.v[0][2]
		print self.v[1][0], self.v[1][1], self.v[1][2]
		print self.v[2][0], self.v[2][1], self.v[2][2]
		print self.v[3][0], self.v[3][1], self.v[3][2]
		print self.v[0][0], self.v[0][1], self.v[0][2]
		print

	def draw2D( self ) :
		print self.img[0][0], self.img[0][1]
		print self.img[1][0], self.img[1][1]
		print self.img[2][0], self.img[2][1]
		print self.img[3][0], self.img[3][1]
		print self.img[0][0], self.img[0][1]
		print

	def proyect( self, vo, vc, va ) :
		self.vc = vc - vo
		k = numpy.linalg.norm( self.vc )
		vz = self.vc / k

		v3 = numpy.cross( va, vz )
		vx = v3/numpy.linalg.norm(v3)

		vy = numpy.cross( vz, vx )

		self.R = numpy.matrix ( [ vx, vy, vz ] )
		# print self.R
		alfa1 = math.atan2( self.R[2,1], -self.R[2,0] )
		self.theta1 = math.degrees( alfa1 )

		beta1 = math.acos( self.R[2,2] )
		self.theta2 = math.degrees( beta1 )

		gama1 = math.atan2( self.R[1,2], self.R[0,2] )
		self.theta3 = math.degrees( gama1 )

		# print "(theta3, theta2, theta2) = ", theta3, theta2, theta1

		vp = numpy.matrix( [ [0.0], [0.0], [0.0]] )
		i = 0
		while i<4 :
			vr = self.v[i]
			#
			# Here it is calculated vp = T(-c) vr
			# 
			vp[0] = vr[0] - self.vc[0]
			vp[1] = vr[1] - self.vc[1]
			vp[2] = vr[2] - self.vc[2]

			v3 = self.R * vp
			v2 = Marker.K * v3

			self.img[i][0] = int(v2[0]/v2[2] + 0.5)
			self.img[i][1] = int(v2[1]/v2[2] + 0.5)

			i += 1

