# encoding: utf-8
import numpy
import sys
import marker

if len( sys.argv ) != 10 :
	# vo point on the object where camera is viewing
	# vc camera center 
	# va vector that indicates up direction
	print "Args: ox oy oz cx cy cz up_x up_y up_z"
	sys.exit(1)

vo = numpy.array( [ float(sys.argv[1]), float(sys.argv[2]), float(sys.argv[3]) ] )
vc = numpy.array( [ float(sys.argv[4]), float(sys.argv[5]), float(sys.argv[6]) ] )
va = numpy.array( [ float(sys.argv[7]), float(sys.argv[8]), float(sys.argv[9]) ] )

fiducial = marker.Marker( )

fiducial.create( [-10.0, -10.0], [ 10.0, 10.0] )

fiducial.proyect( vo, vc, va )

print "f=", marker.Marker.K[0,0]
print "R=", fiducial.R
print "(theta3, theta2, theta1) = ", fiducial.theta3, fiducial.theta2, fiducial.theta1
print "Camera center: ", fiducial.vc
 
# fiducial.draw3D( )
print "Image points:"
fiducial.draw2D( )
