p1 = [ 10.0  10.0;
      -10.0  10.0;
      -10.0 -10.0;
       10.0 -10.0 ];

p2 = [ 458.0 242.0;
       226.0 279.0;
       118.0 151.0;
       399.0  95.0 ];

# Calculamos medias y sigmas de los puntos p1:
[med1, sig1] = meanSigma( p1 );
# med1
# sig1

# Calculamos medias y sigmas de los puntos p2:
[med2, sig2] = meanSigma( p2 );

for i=1:4
	k = 2*i - 1;

	u1 = ( p1(i, 1) - med1(1) ) / sig1(1);
	v1 = ( p1(i, 2) - med1(2) ) / sig1(2);

	u2 = ( p2(i, 1) - med2(1) ) / sig2(1);
	v2 = ( p2(i, 2) - med2(2) ) / sig2(2);

	A( k, 1 ) = u1; 
	A( k, 2 ) = v1; 
	A( k, 3 ) = 1.0;
	A( k, 4 ) = 0.0;
	A( k, 5 ) = 0.0;
	A( k, 6 ) = 0.0;
	A( k, 7 ) = - u1 * u2;
	A( k, 8 ) = - v1 * u2;

    b(k) = u2;

	k = 2*i;
	A( k, 1 ) = 0.0;
	A( k, 2 ) = 0.0;
	A( k, 3 ) = 0.0;
	A( k, 4 ) = u1;
	A( k, 5 ) = v1;
	A( k, 6 ) = 1.0;
	A( k, 7 ) = - u1 * v2;
	A( k, 8 ) = - v1 * v2;

    b(k) = v2;
endfor

hp = A \ b';

Hp = [ hp(1) hp(2) hp(3);
       hp(4) hp(5) hp(6);
       hp(7) hp(8)  1.0 ]

T1 = [ 1/sig1(1)      0     -med1(1)/sig1(1); 
          0      1/sig1(2)  -med1(2)/sig1(2);
          0           0            1          ];

T2i = [ sig2(1)       0         med2(1); 
          0        sig2(2)      med2(2);
          0           0            1          ];

# l p2 = H p1
# l T2 p2 = H T1 p1

H = T2i * Hp * T1

# Test:
for i=1:4
	p = p1(i, :)';
	p(3) = 1.0;
	# p
	uv = H*p;
	u = uv(1)/uv(3); 
	v = uv(2)/uv(3); 
	fprintf("%f %f\n", u, v );
end

u0 = -300;
v0 = -200;
w33 = ( -H(1,2)*( H(1,1) + H(3,1)*u0 )
       - H(2,2)*( H(2,1) + H(3,1)*v0 )
       - H(3,2)*H(1,1)*u0
       - H(3,2)*H(2,1)*v0  )/( H(3,2)*H(3,1) );

f2 = w33 - u0*u0 - v0*v0;
f = sqrt( f2 )

K = [ f  0  u0;
      0  f  v0;
      0  0  -1 ]; 

Kinv = [ 1/f  0   u0/f;
          0  1/f  v0/f;
          0   0    -1 ]; 

A = Kinv * H;
l1 = norm( A(:,1) );
l2 = norm( A(:,2) );
l = (l1+l2)/2.0;

A2 = (1.0/l)*A;

vt =  [ A2(1,3);
        A2(2,3);
        A2(3,3)  ];

Rp = A2;
Rp(:,3) = cross( Rp(:,1), Rp(:,2) ); 

Rp

[U, vd, V] = svd( Rp );
R = U * V'

alfa1 = atan2( R(3,2), -R(3,1) );
theta1 = alfa1*180/pi

beta1 = acos( R(3,3) );
theta2 = beta1*180/pi

gama1 = atan2( R(2,3), R(1,3) );
theta3 = gama1*180/pi

vc = -R' * vt

